package net.cattaka.learnukiukiweb;

import java.util.List;

import com.google.android.maps.GeoPoint;

import net.cattaka.learnukiukiweb.client.UkiukiBallInfo;
import net.cattaka.learnukiukiweb.client.UkiukiClient;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

public class LearnUkiukiWeb extends Activity implements View.OnClickListener {
	public static final String TAG = "LearnUkiukiWeb";
	private UkiukiClient mUkiukiClient = new UkiukiClient();

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		// イベントハンドラを設定
		findViewById(R.id.SubmitButton).setOnClickListener(this);
	}

	@Override
	public void onClick(View v) {
		if (v.getId() == R.id.SubmitButton) {
			// 画面に入力されたパラメータの値を取得準備する
			String apiKey;
			int latitudeE6;
			int longitudeE6;
			EditText apiKeyEdit = (EditText) findViewById(R.id.ApiKeyEdit);
			apiKey = apiKeyEdit.getText().toString();
			try {
				EditText latEdit = (EditText) findViewById(R.id.LatEdit);
				EditText lngEdit = (EditText) findViewById(R.id.LngEdit);
				double latitude = Double.parseDouble(latEdit.getText().toString()) ;
				double longitude = Double.parseDouble(lngEdit.getText().toString()) ;
				
				latitudeE6 = (int) (latitude * 1e6);
				longitudeE6 = (int) (longitude * 1e6);
			} catch (NumberFormatException e) {
				// 数値以外を入れられたらエラー
				Toast.makeText(this, "Value is not a number.", Toast.LENGTH_LONG);
				return;
			}
			GeoPoint geoPoint = new GeoPoint(latitudeE6, longitudeE6);
			
			// リクエストを送信する
			// 注意：通信処理なので本来はUIスレッドでやるべきではない
			List<UkiukiBallInfo> ukiukiBallInfoList = mUkiukiClient.getUkiukiBallInfoList(apiKey, geoPoint);
			if (ukiukiBallInfoList == null) {
				Toast.makeText(this, "getUkiukiBallInfoList failed???", Toast.LENGTH_LONG);
				return;
			}
			
			// 参考用の処理。結果を画面に出力している
			StringBuilder sb = new StringBuilder();
			sb.append("Number of results : " + ukiukiBallInfoList.size() + '\n');
			for (UkiukiBallInfo ukiukiBallInfo : ukiukiBallInfoList) {
				sb.append(ukiukiBallInfo.toDisplayString());
				sb.append('\n');
			}
			EditText resultText = (EditText) findViewById(R.id.ResultText);
			resultText.setText(sb.toString());
		}
	}
}